<template>
  <div>
    <div class="dashboard__header">
      <h1 class="dashboard__title">سفارش های من</h1>
      <div class="dashboard__actions">
        <Button type="text" color='dark' light round size="sm" @click.native="$router.push('/dashboard')">
          <template #icon>
            <BackIcon />
          </template>
        </Button>
      </div>
    </div>
    <div class="dashboard__body">
      <DashboardNavigation class="dashboard__nav" active="orders" />
      <div class="dashboard__content">
        <Empty title="سفارشی برای نمایش وجود ندارد." v-if="orders.length === 0"/>
        <OrderList :orders="orders" v-else />
        <Paginate class="paginate" :pages="totalPages" v-if="totalPages > 1" />
      </div>
    </div>
  </div>
</template>

<script>
import Card from "@/components/base/Card";
import Button from "@/components/base/Button";
import TextField from "@/components/base/TextField";
import BackIcon from "@/assets/svgs/back.svg";
import DashboardNavigation from "@/components/layout/DashboardNavigation";
import OrderList from "@/components/orders/OrderList";
import Empty from "@/components/dashboard/Empty"
import Paginate from "@/components/base/Paginate";

export default {
  components: {
    Card,
    Empty,
    Button,
    TextField,
    BackIcon,
    DashboardNavigation,
    OrderList,
    Paginate
  },
  layout: 'dashboard',
  head() {
    return {
      title: "سفارش های من"
    }
  },
  key(route) {
    return route.fullPath;
  },
  async asyncData(context) {
    let orders;
    let currentPage, totalPages;
    const token = context.store.getters['auth/getToken'];
    const page = context.route.query.page || 1;
    await context.store.dispatch('orders/fetchUserOrders', {token}).then(response => {
      orders = response.data.data.map(cur => {
        if (!cur.order.status) cur.order.status = "1";
        return cur;
      });
      currentPage = response.data.meta.current_page;
      totalPages = response.data.meta.last_page;
    }).catch(error => {
      console.log(error);
    });
    return {
      orders,
      currentPage,
      totalPages
    }
  },
  methods: {
    fetchOrders() {
      const token = this.$store.getters['auth/getToken'];
      const page = this.$route.query.page;
      this.$store.dispatch('orders/fetchUserOrders', {token, page}).then(response => {
        this.orders = response.data.data.map(cur => {
          if (!cur.order.status) cur.order.status = "1";
          return cur;
        });
        this.currentPage = response.data.meta.current_page;
        this.totalPages = response.data.meta.last_page;
      }).catch(e => {
        console.log(e);
      });
    }
  },
  created() {
    const displaying = Number(this.$route.query.page) || 1;
    if (this.currentPage !== displaying) {
      this.fetchOrders();
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.paginate
  width max-content
  margin $lg auto
</style>